DevExtreme v23.2 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

Overview

When you add a Calendar to an application, you need to specify its value in one of the following formats:

  • Date
    Specifies the date directly.

  • Number
    Specifies the date with a timestamp (total milliseconds since 1970/01/01).

  • String
    Specifies the date with a string value. The UI component supports the following formats of a date string:

    • "yyyy-MM-dd" (for example, "2017-03-06")
    • "yyyy-MM-ddTHH:mm:ss" (for example, "2017-03-27T16:54:48")
    • "yyyy-MM-ddTHH:mm:ssZ" (for example, "2017-03-27T13:55:41Z")
    • "yyyy-MM-ddTHH:mm:ssx" (for example, "2017-03-27T16:54:10+03")
  • Array of the formats mentioned before
    Available only for 'multiple' and 'range' selection modes. The array includes all selected dates.

This demo shows how to use additional properties to customize your Calendar. You can toggle the checkboxes on the right to change the Calendar in real time.

Specify First Day of Week and Display Week Numbers

To specify the first day of the week, assign its index (0 - for Sunday, 1 - for Monday, and so on) to the firstDayOfWeek property. You can also display a column with week numbers. For this, enable the showWeekNumbers property.

The start of the first week of the year depends on the locale. If you want to apply a specific rule, use the weekNumberRule property.

Handle Value Change

Set the onValueChanged property to handle the value change. In this demo, the DateBox and the Calendar both use this property to pass values between each other, and you can use one of these components to change the date.

Customize Cell Appearance

Use the cellTemplate property to customize cell appearance. In this demo, the following customizations are applied when you toggle the "Use custom cell template" checkbox:

  • All the weekends on the Calendar become blue.

  • All the holidays become red.

  • If a column with week numbers is shown, week numbers are italicized.

You can set your own function that changes the class of the span element that contains cell text.

Other Customizations

Set the disabled property to disable the Calendar.

To specify the initial calendar view (month, year, decade, or century), set the zoomLevel property.

Backend API
$(() => { const zoomLevels = ['month', 'year', 'decade', 'century']; const weekDays = [ { id: 0, text: 'Sunday' }, { id: 1, text: 'Monday' }, { id: 2, text: 'Tuesday' }, { id: 3, text: 'Wednesday' }, { id: 4, text: 'Thursday' }, { id: 5, text: 'Friday' }, { id: 6, text: 'Saturday' }, ]; const weekNumberRules = ['auto', 'firstDay', 'firstFourDays', 'fullWeek']; const calendar = $('#calendar').dxCalendar({ value: new Date(), disabled: false, firstDayOfWeek: 0, showWeekNumbers: false, weekNumberRule: 'auto', zoomLevel: zoomLevels[0], onValueChanged(data) { selectedDate.option('value', data.value); }, onOptionChanged(data) { if (data.name === 'zoomLevel') { zoomLevel.option('value', data.value); } }, }).dxCalendar('instance'); const zoomLevel = $('#zoom-level').dxSelectBox({ dataSource: zoomLevels, value: zoomLevels[0], inputAttr: { 'aria-label': 'Zoom Level' }, onValueChanged(data) { calendar.option('zoomLevel', data.value); }, }).dxSelectBox('instance'); const selectedDate = $('#selected-date').dxDateBox({ value: new Date(), inputAttr: { 'aria-label': 'Date' }, onValueChanged(data) { calendar.option('value', data.value); }, }).dxDateBox('instance'); $('#custom-cell').dxCheckBox({ text: 'Use custom cell template', value: false, onValueChanged(data) { calendar.option('cellTemplate', data.value ? getCellTemplate : 'cell'); }, }); $('#disabled').dxCheckBox({ text: 'Disable the calendar', onValueChanged(data) { calendar.option('disabled', data.value); }, }); $('#week-numbers').dxCheckBox({ text: 'Show week numbers', onValueChanged(data) { calendar.option('showWeekNumbers', data.value); }, }); $('#first-day-of-week').dxSelectBox({ dataSource: weekDays, value: 0, valueExpr: 'id', inputAttr: { 'aria-label': 'First Day of Week' }, displayExpr: 'text', onValueChanged(data) { calendar.option('firstDayOfWeek', data.value); }, }); $('#week-number-rule').dxSelectBox({ dataSource: weekNumberRules, value: weekNumberRules[0], inputAttr: { 'aria-label': 'Week Number Rule' }, onValueChanged(data) { calendar.option('weekNumberRule', data.value); }, }); const holidays = [[1, 0], [4, 6], [25, 11]]; function isWeekend(d) { const day = d.getDay(); return day === 0 || day === 6; } function getCellTemplate(data) { let cssClass = ''; if (data.view === 'month') { if (!data.date) { cssClass = 'week-number'; } else { if (isWeekend(data.date)) { cssClass = 'weekend'; } $.each(holidays, (_, item) => { if (data.date.getDate() === item[0] && data.date.getMonth() === item[1]) { cssClass = 'holiday'; return false; } return true; }); } } return `<span class='${cssClass}'>${data.text}</span>`; } });
<!DOCTYPE html> <html xmlns="http://www.w3.org/1999/xhtml"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" /> <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script> <script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/23.2.6/css/dx.light.css" /> <script src="js/dx.all.js"></script> <link rel="stylesheet" type="text/css" href="styles.css" /> <script src="index.js"></script> </head> <body class="dx-viewport"> <div class="demo-container" id="calendar-demo"> <div class="calendar-container"> <div id="calendar"></div> </div> <div class="options"> <div class="caption">Options</div> <div class="option"> <span>Zoom level</span> <div id="zoom-level"></div> </div> <div class="option"> <span>Selected date</span> <div id="selected-date"></div> </div> <div class="option"> <div id="custom-cell"></div> </div> <div class="option"> <div id="disabled"></div> </div> <div class="caption option"> <span>Week numeration</span> </div> <div class="option"> <div id="week-numbers"></div> </div> <div class="option"> <span>First day of week</span> <div id="first-day-of-week"></div> </div> <div class="option"> <span>Week number rule</span> <div id="week-number-rule"></div> </div> </div> </div> </body> </html>
#calendar-demo { display: flex; } .calendar-container { display: flex; flex-direction: column; flex-grow: 1; align-items: center; justify-content: center; } .dx-calendar-cell:not(.dx-calendar-other-month) .weekend, .dx-calendar-cell:not(.dx-calendar-other-month) .holiday { text-shadow: none; font-weight: bold; } .dx-calendar-cell:not(.dx-calendar-other-month) .weekend { color: #3030ff; } .dx-state-disabled.dx-calendar .dx-calendar-cell:not(.dx-calendar-other-month) .weekend { color: #8080ff; } .dx-calendar-cell:not(.dx-calendar-other-month) .holiday { color: #ff3030; } .dx-state-disabled.dx-calendar .dx-calendar-cell:not(.dx-calendar-other-month) .holiday { color: #ff8080; } .dx-calendar-week-number-cell .week-number { font-style: italic; } .caption { font-weight: 500; font-size: 18px; } .options { padding: 20px; background-color: rgba(191, 191, 191, 0.15); } .option { margin-top: 10px; }

DevExtreme v23.2 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

Overview

When you add a Calendar to an application, you need to specify its value in one of the following formats:

  • Date objects

  • The number of milliseconds since 00:00:00 on January 1, 1970

  • Strings that match the following patterns:

    • 'yyyy-MM-dd'
    • 'yyyy-MM-ddTHH:mm:ss'
    • 'yyyy-MM-ddTHH:mm:ssZ'
    • 'yyyy-MM-ddTHH:mm:ssx'

This demo shows how to use additional properties to customize your Calendar. You can toggle the checkboxes on the right to change the Calendar in real time.

Disable Dates

Use the min and max properties to specify the range of available dates. In this demo, these properties limit the range to three days before and after the current date. Enable the "Set minimum date" and "Set maximum date" checkboxes to apply the properties.

If you need to disable specific dates, use the disabledDates property. Toggle the "Disable weekends" checkbox to see how this setting affects the component's behavior. You can specify either an array of predefined dates or a function that determines whether a date is available.

Specify First Day of Week and Display Week Numbers

To specify the first day of the week, assign its index (0 - for Sunday, 1 - for Monday, and so on) to the firstDayOfWeek property. You can also display a column with week numbers. For this, enable the showWeekNumbers property.

Handle Value Change

To handle value changes, use two-way binding to bind the value properties of different components. In this demo, you can use the DateBox or Calendar component to change the date because their value properties are bound.

Customize Cell Appearance

Use the cellTemplate property to customize cell appearance. In this demo, the following customizations are applied when you toggle the "Use custom cell template" checkbox:

  • All the weekends on the Calendar become blue.

  • All the holidays become red.

  • If a column with week numbers is shown, week numbers are italicized.

You can set your own function that changes the class of the span element that contains cell text.

Other Customizations

Set the disabled property to disable the Calendar.

To specify the initial calendar view (month, year, decade, or century), set the zoomLevel property.

Backend API
<template> <div id="calendar-demo"> <div class="calendar-container"> <DxCalendar v-model:value="currentValue" v-model:zoom-level="zoomLevel" :first-day-of-week="firstDay" :show-week-numbers="showWeekNumbers" :week-number-rule="weekNumberRule" :disabled="disabled" :cell-template="cellTemplate" > <template #custom="{ data: cell }"> <span :class="getCellCssClass(cell)"> {{ cell.text }} </span> </template> </DxCalendar> </div> <div class="options"> <div class="caption">Options</div> <div class="option"> <span>Zoom level</span> <DxSelectBox v-model:value="zoomLevel" :input-attr="{ 'aria-label': 'Zoom Level' }" :data-source="zoomLevels" /> </div> <div class="option"> <span>Selected date</span> <DxDateBox v-model:value="currentValue" :input-attr="{ 'aria-label': 'Date' }" /> </div> <div class="option"> <DxCheckBox :value="false" text="Use custom cell template" @value-changed="useCellTemplate" /> </div> <div class="option"> <DxCheckBox v-model:value="disabled" text="Disable the calendar" /> </div> <div class="caption option"> <span>Week numeration</span> </div> <div class="option"> <DxCheckBox v-model:value="showWeekNumbers" text="Show week numbers" /> </div> <div class="option"> <span>First day of week</span> <DxSelectBox v-model:value="firstDay" :data-source="weekDays" :input-attr="{ 'aria-label': 'First Day of Week' }" value-expr="id" display-expr="text" /> </div> <div class="option"> <span>Week number rule</span> <DxSelectBox v-model:value="weekNumberRule" :input-attr="{ 'aria-label': 'Week Number Rule' }" :data-source="weekNumberRules" /> </div> </div> </div> </template> <script setup lang="ts"> import { ref } from 'vue'; import DxCheckBox from 'devextreme-vue/check-box'; import DxSelectBox from 'devextreme-vue/select-box'; import DxDateBox from 'devextreme-vue/date-box'; import DxCalendar from 'devextreme-vue/calendar'; const zoomLevels = ['month', 'year', 'decade', 'century']; const zoomLevel = ref('month'); const currentValue = ref(new Date()); const cellTemplate = ref('cell'); const disabled = ref(false); const showWeekNumbers = ref(false); const firstDay = ref(0); const weekNumberRule = ref('auto'); const weekDays = [ { id: 0, text: 'Sunday' }, { id: 1, text: 'Monday' }, { id: 2, text: 'Tuesday' }, { id: 3, text: 'Wednesday' }, { id: 4, text: 'Thursday' }, { id: 5, text: 'Friday' }, { id: 6, text: 'Saturday' }, ]; const weekNumberRules = ['auto', 'firstDay', 'firstFourDays', 'fullWeek']; function isWeekend(date) { const day = date.getDay(); return day === 0 || day === 6; } function useCellTemplate({ value }) { cellTemplate.value = value ? 'custom' : 'cell'; } function getCellCssClass({ date, view }) { let cssClass = ''; const holidays = [[1, 0], [4, 6], [25, 11]]; if (view === 'month') { if (!date) { cssClass = 'week-number'; } else { if (isWeekend(date)) { cssClass = 'weekend'; } holidays.forEach((item) => { if (date.getDate() === item[0] && date.getMonth() === item[1]) { cssClass = 'holiday'; } }); } } return cssClass; } </script> <style scoped> #calendar-demo { display: flex; } .calendar-container { display: flex; flex-direction: column; flex-grow: 1; align-items: center; justify-content: center; } .dx-calendar-cell:not(.dx-calendar-other-month) .weekend, .dx-calendar-cell:not(.dx-calendar-other-month) .holiday { text-shadow: none; font-weight: bold; } .dx-calendar-cell:not(.dx-calendar-other-month) .weekend { color: #3030ff; } .dx-state-disabled.dx-calendar .dx-calendar-cell:not(.dx-calendar-other-month) .weekend { color: #8080ff; } .dx-calendar-cell:not(.dx-calendar-other-month) .holiday { color: #ff3030; } .dx-state-disabled.dx-calendar .dx-calendar-cell:not(.dx-calendar-other-month) .holiday { color: #ff8080; } .dx-calendar-week-number-cell .week-number { font-style: italic; } .caption { font-weight: 500; font-size: 18px; } .options { padding: 20px; background-color: rgba(191, 191, 191, 0.15); } .option { margin-top: 10px; } </style>
window.exports = window.exports || {}; window.config = { transpiler: 'plugin-babel', meta: { '*.vue': { loader: 'vue-loader', }, '*.ts': { loader: 'demo-ts-loader', }, '*.svg': { loader: 'svg-loader', }, 'devextreme/time_zone_utils.js': { 'esModule': true, }, 'devextreme/localization.js': { 'esModule': true, }, 'devextreme/viz/palette.js': { 'esModule': true, }, }, paths: { 'root:': '../../../../../', 'npm:': 'https://unpkg.com/', }, map: { 'vue': 'npm:vue@3.3.4/dist/vue.esm-browser.js', 'vue-loader': 'npm:dx-systemjs-vue-browser@1.1.1/index.js', 'demo-ts-loader': 'root:utils/demo-ts-loader.js', 'svg-loader': 'root:utils/svg-loader.js', 'mitt': 'npm:mitt/dist/mitt.umd.js', 'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js', 'luxon': 'npm:luxon@1.28.1/build/global/luxon.min.js', 'es6-object-assign': 'npm:es6-object-assign@1.1.0', 'devextreme': 'npm:devextreme@23.2.6/cjs', 'devextreme-vue': 'npm:devextreme-vue@23.2.6/cjs', 'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js', 'devextreme-quill': 'npm:devextreme-quill@1.6.4/dist/dx-quill.min.js', 'devexpress-diagram': 'npm:devexpress-diagram@2.2.5/dist/dx-diagram.js', 'devexpress-gantt': 'npm:devexpress-gantt@4.1.54/dist/dx-gantt.js', '@devextreme/runtime': 'npm:@devextreme/runtime@3.0.12', 'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js', 'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js', 'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js', 'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js', 'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js', 'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js', 'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js', 'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js', 'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js', 'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js', // Prettier 'prettier/standalone': 'npm:prettier@2.8.4/standalone.js', 'prettier/parser-html': 'npm:prettier@2.8.4/parser-html.js', }, packages: { 'devextreme-vue': { main: 'index.js', }, 'devextreme': { defaultExtension: 'js', }, 'devextreme/events/utils': { main: 'index', }, 'devextreme/events': { main: 'index', }, 'es6-object-assign': { main: './index.js', defaultExtension: 'js', }, }, packageConfigPaths: [ 'npm:@devextreme/*/package.json', 'npm:@devextreme/runtime@3.0.12/inferno/package.json', ], babelOptions: { sourceMaps: false, stage0: true, }, }; System.config(window.config);
import { createApp } from 'vue'; import App from './App.vue'; createApp(App).mount('#app');
<!DOCTYPE html> <html> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" /> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/23.2.6/css/dx.light.css" /> <link rel="stylesheet" type="text/css" href="https://maxcdn.bootstrapcdn.com/font-awesome/4.6.3/css/font-awesome.min.css" /> <script type="module"> import * as vueCompilerSFC from "https://unpkg.com/@vue/compiler-sfc@3.3.4/dist/compiler-sfc.esm-browser.js"; window.vueCompilerSFC = vueCompilerSFC; </script> <script src="https://unpkg.com/typescript@4.2.4/lib/typescript.js"></script> <script src="https://unpkg.com/core-js@2.6.12/client/shim.min.js"></script> <script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script> <script type="text/javascript" src="config.js"></script> <script type="text/javascript"> System.import("./index.ts"); </script> </head> <body class="dx-viewport"> <div class="demo-container"> <div id="app"> </div> </div> </body> </html>

If you have technical questions, please create a support ticket in the DevExpress Support Center.
import React, { useCallback, useState } from 'react';
import CheckBox from 'devextreme-react/check-box';
import SelectBox from 'devextreme-react/select-box';
import DateBox from 'devextreme-react/date-box';
import Calendar, { CalendarTypes } from 'devextreme-react/calendar';
import CustomCell from './CustomCell.tsx';
const zoomLevels = ['month', 'year', 'decade', 'century'];
const weekNumberRules = ['auto', 'firstDay', 'firstFourDays', 'fullWeek'];
const weekDays = [
{ id: 0, text: 'Sunday' },
{ id: 1, text: 'Monday' },
{ id: 2, text: 'Tuesday' },
{ id: 3, text: 'Wednesday' },
{ id: 4, text: 'Thursday' },
{ id: 5, text: 'Friday' },
{ id: 6, text: 'Saturday' },
];
const dateBoxLabel = { 'aria-label': 'Date' };
const zoomLevelLabel = { 'aria-label': 'Zoom Level' };
const dayLabel = { 'aria-label': 'First Day of Week' };
const ruleLabel = { 'aria-label': 'Week Number Rule' };
export default function App() {
const [zoomLevel, setZoomLevel] = useState<CalendarTypes.CalendarZoomLevel>('month');
const [currentValue, setCurrentValue] = useState(new Date());
const [useCellTemplate, setUseCellTemplate] = useState(null);
const [disabled, setDisabled] = useState(false);
const [showWeekNumbers, setShowWeekNumbers] = useState(false);
const [firstDay, setFirstDay] = useState<CalendarTypes.FirstDayOfWeek>(0);
const [weekNumberRule, setWeekNumberRule] = useState<CalendarTypes.WeekNumberRule>('auto');
const onCurrentValueChange = useCallback(
({ value }) => {
setCurrentValue(value);
},
[setCurrentValue],
);
const onDisabledChange = useCallback(
({ value }) => {
setDisabled(value);
},
[setDisabled],
);
const onZoomLevelChange = useCallback(
({ value }) => {
setZoomLevel(value);
},
[setZoomLevel],
);
const onFirstDayChange = useCallback(
({ value }) => {
setFirstDay(value);
},
[setFirstDay],
);
const onWeekNumberRuleChange = useCallback(
({ value }) => {
setWeekNumberRule(value);
},
[setWeekNumberRule],
);
const onShowWeekNumbersChange = useCallback(
({ value }) => {
setShowWeekNumbers(value);
},
[setShowWeekNumbers],
);
const onUseCellTemplateChange = useCallback(
({ value }) => {
setUseCellTemplate(!!value);
},
[setUseCellTemplate],
);
const onOptionChange = useCallback(
(e: { name: string }) => {
if (e.name === 'zoomLevel') {
onZoomLevelChange(e);
}
},
[onZoomLevelChange],
);
return (
<div id="calendar-demo">
<div className="calendar-container">
<Calendar
value={currentValue}
onValueChanged={onCurrentValueChange}
onOptionChanged={onOptionChange}
firstDayOfWeek={firstDay}
weekNumberRule={weekNumberRule}
showWeekNumbers={showWeekNumbers}
disabled={disabled}
zoomLevel={zoomLevel}
cellComponent={useCellTemplate ? CustomCell : null}
/>
</div>
<div className="options">
<div className="caption">Options</div>
<div className="option">
<span>Zoom level</span>
<SelectBox
dataSource={zoomLevels}
value={zoomLevel}
inputAttr={zoomLevelLabel}
onValueChanged={onZoomLevelChange}
/>
</div>
<div className="option">
<span>Selected date</span>
<DateBox
id="selected-date"
value={currentValue}
onValueChanged={onCurrentValueChange}
inputAttr={dateBoxLabel}
/>
</div>
<div className="option">
<CheckBox
defaultValue={false}
text="Use custom cell template"
onValueChanged={onUseCellTemplateChange}
/>
</div>
<div className="option">
<CheckBox
value={disabled}
text="Disable the calendar"
onValueChanged={onDisabledChange}
/>
</div>
<div className="caption option">
<span>Week numeration</span>
</div>
<div className="option">
<CheckBox
defaultValue={false}
text="Show week numbers"
onValueChanged={onShowWeekNumbersChange}
/>
</div>
<div className="option">
<span>First day of week</span>
<SelectBox
dataSource={weekDays}
inputAttr={dayLabel}
displayExpr="text"
valueExpr="id"
value={firstDay}
onValueChanged={onFirstDayChange}
/>
</div>
<div className="option">
<span>Week number rule</span>
<SelectBox
dataSource={weekNumberRules}
inputAttr={ruleLabel}
value={weekNumberRule}
onValueChanged={onWeekNumberRuleChange}
/>
</div>
</div>
</div>
);
}
xxxxxxxxxx
import React, { useCallback, useState } from 'react';
import CheckBox from 'devextreme-react/check-box';
import SelectBox from 'devextreme-react/select-box';
import DateBox from 'devextreme-react/date-box';
import Calendar from 'devextreme-react/calendar';
import CustomCell from './CustomCell.js';
const zoomLevels = ['month', 'year', 'decade', 'century'];
const weekNumberRules = ['auto', 'firstDay', 'firstFourDays', 'fullWeek'];
const weekDays = [
{ id: 0, text: 'Sunday' },
{ id: 1, text: 'Monday' },
{ id: 2, text: 'Tuesday' },
{ id: 3, text: 'Wednesday' },
{ id: 4, text: 'Thursday' },
{ id: 5, text: 'Friday' },
{ id: 6, text: 'Saturday' },
];
const dateBoxLabel = { 'aria-label': 'Date' };
const zoomLevelLabel = { 'aria-label': 'Zoom Level' };
const dayLabel = { 'aria-label': 'First Day of Week' };
const ruleLabel = { 'aria-label': 'Week Number Rule' };
export default function App() {
const [zoomLevel, setZoomLevel] = useState('month');
const [currentValue, setCurrentValue] = useState(new Date());
const [useCellTemplate, setUseCellTemplate] = useState(null);
const [disabled, setDisabled] = useState(false);
const [showWeekNumbers, setShowWeekNumbers] = useState(false);
const [firstDay, setFirstDay] = useState(0);
const [weekNumberRule, setWeekNumberRule] = useState('auto');
const onCurrentValueChange = useCallback(
({ value }) => {
setCurrentValue(value);
},
[setCurrentValue],
);
const onDisabledChange = useCallback(
({ value }) => {
setDisabled(value);
},
[setDisabled],
);
const onZoomLevelChange = useCallback(
({ value }) => {
setZoomLevel(value);
},
[setZoomLevel],
);
const onFirstDayChange = useCallback(
({ value }) => {
setFirstDay(value);
},
[setFirstDay],
);
const onWeekNumberRuleChange = useCallback(
({ value }) => {
setWeekNumberRule(value);
},
[setWeekNumberRule],
);
const onShowWeekNumbersChange = useCallback(
({ value }) => {
setShowWeekNumbers(value);
},
[setShowWeekNumbers],
);
const onUseCellTemplateChange = useCallback(
({ value }) => {
setUseCellTemplate(!!value);
},
[setUseCellTemplate],
);
const onOptionChange = useCallback(
(e) => {
if (e.name === 'zoomLevel') {
onZoomLevelChange(e);
}
},
[onZoomLevelChange],
);
return (
<div id="calendar-demo">
<div className="calendar-container">
<Calendar
value={currentValue}
onValueChanged={onCurrentValueChange}
onOptionChanged={onOptionChange}
firstDayOfWeek={firstDay}
weekNumberRule={weekNumberRule}
showWeekNumbers={showWeekNumbers}
disabled={disabled}
zoomLevel={zoomLevel}
cellComponent={useCellTemplate ? CustomCell : null}
/>
</div>
<div className="options">
<div className="caption">Options</div>
<div className="option">
<span>Zoom level</span>
<SelectBox
dataSource={zoomLevels}
value={zoomLevel}
inputAttr={zoomLevelLabel}
onValueChanged={onZoomLevelChange}
/>
</div>
<div className="option">
<span>Selected date</span>
<DateBox
id="selected-date"
value={currentValue}
onValueChanged={onCurrentValueChange}
inputAttr={dateBoxLabel}
/>
</div>
<div className="option">
<CheckBox
defaultValue={false}
text="Use custom cell template"
onValueChanged={onUseCellTemplateChange}
/>
</div>
<div className="option">
<CheckBox
value={disabled}
text="Disable the calendar"
onValueChanged={onDisabledChange}
/>
</div>
<div className="caption option">
<span>Week numeration</span>
</div>
<div className="option">
<CheckBox
defaultValue={false}
text="Show week numbers"
onValueChanged={onShowWeekNumbersChange}
/>
</div>
<div className="option">
<span>First day of week</span>
<SelectBox
dataSource={weekDays}
inputAttr={dayLabel}
displayExpr="text"
valueExpr="id"
value={firstDay}
onValueChanged={onFirstDayChange}
/>
</div>
<div className="option">
<span>Week number rule</span>
<SelectBox
dataSource={weekNumberRules}
inputAttr={ruleLabel}
value={weekNumberRule}
onValueChanged={onWeekNumberRuleChange}
/>
</div>
</div>
</div>
);
}
xxxxxxxxxx
import React from 'react';
export function isWeekend(date: Date) {
const day = date.getDay();
return day === 0 || day === 6;
}
function getCellCssClass({ date, view }) {
let cssClass = '';
const holidays = [
[1, 0],
[4, 6],
[25, 11],
];
if (view === 'month') {
if (!date) {
cssClass = 'week-number';
} else {
if (isWeekend(date)) {
cssClass = 'weekend';
}
holidays.forEach((item) => {
if (date.getDate() === item[0] && date.getMonth() === item[1]) {
cssClass = 'holiday';
}
});
}
}
return cssClass;
}
function CustomCell({ data: cell }) {
const { text } = cell;
const className = getCellCssClass(cell);
return <span className={className}>{text}</span>;
}
export default CustomCell;
xxxxxxxxxx
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(<App />, document.getElementById('app'));
xxxxxxxxxx
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
jsx: 'react',
},
meta: {
'react': {
'esModule': true,
},
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://unpkg.com/',
'bundles:': 'bundles/',
'externals:': 'bundles/externals/',
},
defaultExtension: 'js',
map: {
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@24.2.5/cjs',
'devextreme-react': 'npm:devextreme-react@24.2.5/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.1/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.15/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.59/dist/dx-gantt.js',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.12',
'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.12/inferno/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
System.config(window.config);
xxxxxxxxxx
import React from 'react';
export function isWeekend(date) {
const day = date.getDay();
return day === 0 || day === 6;
}
function getCellCssClass({ date, view }) {
let cssClass = '';
const holidays = [
[1, 0],
[4, 6],
[25, 11],
];
if (view === 'month') {
if (!date) {
cssClass = 'week-number';
} else {
if (isWeekend(date)) {
cssClass = 'weekend';
}
holidays.forEach((item) => {
if (date.getDate() === item[0] && date.getMonth() === item[1]) {
cssClass = 'holiday';
}
});
}
}
return cssClass;
}
function CustomCell({ data: cell }) {
const { text } = cell;
const className = getCellCssClass(cell);
return <span className={className}>{text}</span>;
}
export default CustomCell;
xxxxxxxxxx
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
xxxxxxxxxx
<html lang="en">
<head></head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
xxxxxxxxxx
#calendar-demo {
display: flex;
}
.calendar-container {
display: flex;
flex-direction: column;
flex-grow: 1;
align-items: center;
justify-content: center;
}
.dx-calendar-cell:not(.dx-calendar-other-month) .weekend,
.dx-calendar-cell:not(.dx-calendar-other-month) .holiday {
text-shadow: none;
font-weight: bold;
}
.dx-calendar-cell:not(.dx-calendar-other-month) .weekend {
color: #3030ff;
}
.dx-state-disabled.dx-calendar .dx-calendar-cell:not(.dx-calendar-other-month) .weekend {
color: #8080ff;
}
.dx-calendar-cell:not(.dx-calendar-other-month) .holiday {
color: #ff3030;
}
.dx-state-disabled.dx-calendar .dx-calendar-cell:not(.dx-calendar-other-month) .holiday {
color: #ff8080;
}
.dx-calendar-week-number-cell .week-number {
font-style: italic;
}
.caption {
font-weight: 500;
font-size: 18px;
}
.options {
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
}
.option {
margin-top: 10px;
}
When you add a Calendar to an application, you need to specify its value in one of the following formats:
-
Date
Specifies the date directly. -
Number
Specifies the date with a timestamp (total milliseconds since 1970/01/01). -
String
Specifies the date with a string value. The UI component supports the following formats of a date string:- "yyyy-MM-dd" (for example, "2017-03-06")
- "yyyy-MM-ddTHH:mm:ss" (for example, "2017-03-27T16:54:48")
- "yyyy-MM-ddTHH:mm:ssZ" (for example, "2017-03-27T13:55:41Z")
- "yyyy-MM-ddTHH:mm:ssx" (for example, "2017-03-27T16:54:10+03")
-
Array of the formats mentioned before
Available only for 'multiple' and 'range' selection modes. The array includes all selected dates.
Specify First Day of Week and Display Week Numbers
To specify the first day of the week, assign its index (0 - for Sunday, 1 - for Monday, and so on) to the firstDayOfWeek property. You can also display a column with week numbers. For this, enable the showWeekNumbers property.
The start of the first week of the year depends on the locale. If you want to apply a specific rule, use the weekNumberRule property.
Handle Value Change
Set the onValueChanged property to handle the value change. In this demo, the DateBox and the Calendar both use this property to pass values between each other, and you can use one of these components to change the date.
Customize Cell Appearance
Use the cellTemplate property to customize cell appearance. In this demo, the following customizations are applied when you toggle the "Use custom cell template" checkbox:
-
All the weekends on the Calendar become blue.
-
All the holidays become red.
-
If a column with week numbers is shown, week numbers are italicized.
You can set your own function that changes the class of the span element that contains cell text.
Other Customizations
Set the disabled property to disable the Calendar.
To specify the initial calendar view (month, year, decade, or century), set the zoomLevel property.